// ==============================================================
//                 ORBITER MODULE: CRANEHEAD
//                  Part of the ORBITER SDK
//          Copyright (C) 2002-2004 Martin Schweiger
//                   All rights reserved
//
// CRANEHEAD.cpp
// Control module for CRANEHEAD vessel class
//

// ==============================================================
#define ORBITER_MODULE
#include "orbitersdk.h"
#include "CRANEHEAD.h"
#include "OrbiterSoundSDK35.h"
VISHANDLE MainExternalMeshVisual = 0;


//vertical lift component (wings and body)
CRANEHEAD::~CRANEHEAD ()
{
}








void CRANEHEAD::SelectCockpitView (int CAM)
{

     switch (CAM) {
 case 0:  //PILOT
          SetCameraDefaultDirection (_V(0,0,1));
          SetCameraOffset (_V(0,  -.4 ,-2.3));
		  oapiCameraSetCockpitDir (0,0);
          break;
 case 2:  //BELOW
          SetCameraDefaultDirection (_V(0,-1,0));
          SetCameraOffset (_V(0 ,1,  -.4));
		  oapiCameraSetCockpitDir (0,0);
          break;
case 3:  //ATTACHMENT BELOW
          SetCameraDefaultDirection (_V(-1,0,0));
          SetCameraOffset (_V(0, .248,  5));
		  oapiCameraSetCockpitDir (0,0);
          break;


 }}




void CRANEHEAD::clbkPostCreation (void)

{
	


CRANEHEADID=ConnectToOrbiterSoundDLL3(GetHandle());



//ReplaceStockSound3(CRANEHEADID,"Sound\\Vessel\\MOONBASEALPHA\\ambient.wav",	REPLACE_COCKPIT_AMBIENCE_1);
SoundOptionOnOff3(CRANEHEADID,PLAYMAINTHRUST,FALSE);
//ReplaceStockSound3(CRANEHEADID,"Sound\\Vessel\\CRANEHEAD\\CRANEHEAD.wav",	REPLACE_HOVER_THRUST);

SoundOptionOnOff3(CRANEHEADID,PLAYHOVERTHRUST,TRUE);
ReplaceStockSound3(CRANEHEADID,"Sound\\Vessel\\roll.wav",	REPLACE_RCS_THRUST_ATTACK);

SoundOptionOnOff3(CRANEHEADID,PLAYATTITUDETHRUST,TRUE);

SoundOptionOnOff3(CRANEHEADID,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);

SoundOptionOnOff3(CRANEHEADID,PLAYCABINAIRCONDITIONING,TRUE);

SoundOptionOnOff3(CRANEHEADID,PLAYCABINRANDOMAMBIANCE,TRUE);

SoundOptionOnOff3(CRANEHEADID,PLAYRADIOATC,FALSE);

SoundOptionOnOff3(CRANEHEADID,DISPLAYTIMER,FALSE);

}


// Constructor
//CRANEHEAD::CRANEHEAD (OBJHANDLE hObj, int fmodel)
//: VESSEL2 (hObj, fmodel)

CRANEHEAD::CRANEHEAD (OBJHANDLE hObj, int fmodel)
: baseClass (hObj, fmodel)
{
	j_name[0]	= '\0';
	j_timer		= 0;


//GEARCOVER_status      = GEAR_UP;
//GEARCOVER_proc        = 0.0;
LIFT_SPEED =.25;
CABLE_proc =0;
CABLE_check=0;
CABLEFACTOR = 50.4;
MAX_GRAP_DIST=10;
P1_INT_POS= -.2931572;
DefineAnimations ();
WINCH_SPEED =.25;
	
}

//void CRANEHEAD::PM_clbkPayloadJettisoned(int slot_idx, OBJHANDLE jettisoned_ship)
///{
// Using PM_IsAllDetached method to start the retro motors:
//	if(PM_IsAllDetached())
//		SetThrusterGroupLevel(thg_hover, 1);

//	oapiGetObjectName(jettisoned_ship, j_name, 32);
//	j_timer = -5;
//}

//void CRANEHEAD::PM_clbkVehicleCapsChanged()
//{
	//Here you can make some action on vehicle's capabilities change
//}


//
void CRANEHEAD::clbkSetClassCaps (FILEHANDLE cfg)
//void CRANEHEAD::SetTransporter()
{
	// physical specs
	SetSize (1);
	SetEmptyMass (10);//15000.0  2389
	SetCW (0.3, 0.3, 0.6, 0.9);
	SetWingAspect (0.1);
	SetWingEffectiveness (0.1);
	SetCrossSections (_V(29.73,48.13,12.72));
	SetRotDrag (_V(1.5,1.5,1.5));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (1e-4);
		SetBankMomentScale (1e-4);
	}
	SetPMI (_V(26.20,22.72,17.06));
	SetTrimScale (0.05);
	SetCameraOffset (_V(0,  -.4 ,-2.3));
	SetClipRadius(0.1);
	SetTouchdownPoints  (_V(0,-2.8,9), _V(-4,-2.8,-9), _V(4,-2.8,-9));; //28
EnableTransponder (true);

 SetMaxWheelbrakeForce(200000);

const VECTOR3 PMI = _V(26.20,22.72,17.06);
	const VECTOR3 CS = _V(606, 614, 254);


SetMeshVisibilityMode (AddMesh (oapiLoadMeshGlobal ("CRANEHEAD")), MESHVIS_ALWAYS | MESHVIS_EXTPASS); //Main ship mesh

			
P1 = CreateAttachment (false, _V(0,  -.2931572 ,0 ),_V(0,1,0),_V(0,0,1),"CRANEHEAD",false);
P2 = CreateAttachment (true, _V(0,  .249 ,0 ),_V(0,-1,0),_V(0,0,1),"CRANETOP",false);



	P1_pos.x =  0;
    P1_pos.y = -.2931572;
    P1_pos.z = 0;

//Now it is necessary to tune Payload Manager for your ship
	// default position and orientation for payload slots:
	PM_SetDefaultAttachmentParams(_V(0, 0, 38), _V(0, 0, 1), _V(0, 1, 0));
	// the special definition for default position and orientation for payload slot 0 (up-forward with 30 deg pitch):
	PM_SetSlotAttachmentParams(0, _V(0, 0, 38), _V(0, 0.5, 0.866025404), _V(0, 0.866025404, -0.5));
	// the special definition for default position and orientation for payload slot 1 (down-forward with -30 deg pitch):
	PM_SetSlotAttachmentParams(1, _V(0, 0, 38), _V(0, -0.5, 0.866025404), _V(0, -0.866025404, -0.5));
	// time interval between payload separation, s (1 second by default):
	PM_SetDetachInterval(0.5);
	// speed of payload separation, m/s (1 m/s by default):
	PM_SetDetachSpeed(30);
	// transfer control focus to separated payload if it allows control focus (true by default):
	PM_SetSendFocus(false);
	// let Payload Manager to know Principal Moments of Inertia (PMI) of vehicle ship:
	PM_SetVehiclePMI(PMI);
	// let Payload Manager to know Cross Sections (CS) of vehicle ship and rules of calculating total cross sections:
	PM_SetVehicleCS(CS, _V(0, 0, 1));
	// maximum number of payloads capability for your vehicle ship (10 by default):
	PM_SetMaximumPayloadsNumber(11);
	// setting period of refreshing PMI and CS on 10 seconds
	PM_SetCapsRefreshPeriod(10);





}

// =======================================================
// UMMU Class Caps
// =======================================================


void CRANEHEAD::clbkPostStep(double simt, double simdt, double mjd)
{


		baseClass::clbkPostStep(simt, simdt, mjd);

//---------------------------------------------------------------------------
	// ProcessUniversalMMu
	// Here the routine that detect if someone entered the ship (eva or transfer)
	// No need to manage anything here all is automatic, crew is added to your ship, ship's weight is updated,
	// and UMmu vessel is automatically deleted from Orbiter. You may just look the return
	// code to see if someone entered and display wathewer message on panel or other.
	// notice it's FPS friendly, function process only 4 time per second not each frame 
	// and return immediately if airlock closed or no Ummu is detected in vincinity. 



(P2_pos.y)=(P1_INT_POS-(CABLE_proc*CABLEFACTOR));
if (P2_pos.y> -.5)P2_pos.y=-1.5;
//sprintf(oapiDebugString(),"anim %2.2f ", P2_pos.y);

CAM_pos.x=(0) ;
CAM_pos.z=(-.4);
CAM_pos.y=(P2_pos.y+2) ;
if (CAM_pos.y> 1)CAM_pos.y=2;

CAM1_pos.x=(-2) ;
CAM1_pos.z=(0 );
CAM1_pos.y=(P1_pos.y) ;

if (CAM==1){
	SetCameraDefaultDirection (_V(0,-1,0));
          SetCameraOffset ((CAM_pos));
		  oapiCameraSetCockpitDir (0,0);
}



if (CAM==2){
	SetCameraDefaultDirection (_V(1,0,0));
          SetCameraOffset ((CAM1_pos));
		  oapiCameraSetCockpitDir (0,0);
}


	





if (SPEED==0)WINCH_SPEED=.05;
if (SPEED==1)WINCH_SPEED=.1;

double dc = simdt * WINCH_SPEED;

    if (CABLE_proc > 1) CABLE_proc = 1;
    else if (CABLE_proc < 0) CABLE_proc = 0;

   if (CABLE_check == 1)CABLE_proc = (CABLE_proc + dc);
    else if (CABLE_check == 2)CABLE_proc = (CABLE_proc - dc);
    else if (CABLE_check == 0)CABLE_proc = CABLE_proc;

if (CABLE_proc > 1) CABLE_proc = 1;
    else if (CABLE_proc < 0) CABLE_proc = 0;


      SetAnimation (anim_CABLE, CABLE_proc);
      SetAnimation (anim_CABLE1, CABLE_proc);
    
{P1_pos.y=P1_INT_POS-(CABLE_proc*CABLEFACTOR);
SetAttachmentParams(P1,P1_pos,_V(0,1,0),_V(0,0,1));

}









}

	    
  










void CRANEHEAD::DefineAnimations(void)

{
  	



static UINT EGrp1[1] = {2};//HOOK
  static MGROUP_TRANSLATE CABLE (0,EGrp1, 1, _V(0,-50.6,0));
   
   anim_CABLE = CreateAnimation (0);      
  AddAnimationComponent  (anim_CABLE, 0, 1, &CABLE);   	
  
  	static UINT EGrp2[1] = {0 };//cable
static  MGROUP_SCALE CABLE1 (0, EGrp2, 1, _V(0,-.173,0), _V(1,507.5,1));
   anim_CABLE1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_CABLE1, 0, 1, &CABLE1);   	
	




}
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
return new CRANEHEAD (hvessel, flightmodel);
}

DLLCLBK void ovcExit (VESSEL *vessel)
{
if (vessel) delete (CRANEHEAD*)vessel;
}



// --------------------------------------------------------------
// Keyboard interface handler (buffered key events)
// --------------------------------------------------------------
int CRANEHEAD::clbkConsumeBufferedKey(DWORD key, bool down, char *kstate)
{
	// only process keydown events
	if (!down) 
		return 0; 


if(key==OAPI_KEY_V)
{

    CAM = CAM + 1;
    if(CAM > 2) CAM = 0;
	
        SelectCockpitView(CAM);
        return 1;
}  



if(key==OAPI_KEY_7)
{
    if(SPEED == 1)	SPEED=0; // started
	else	
		if(SPEED == 0)	SPEED=1;
      return 1;
}



if(key==OAPI_KEY_4)
{
      (CABLE_check = 0) ;
        return 1;
}   

if(key==OAPI_KEY_B)
{
do_attach = 1;
             AttachCargo();
             return 1;
}
if(key==OAPI_KEY_N)
{
DetachCargo();
             return 1;
}



if(key==OAPI_KEY_6)
{
     if (CABLE_check == 0) CABLE_check = 1;
        else if (CABLE_check == 1) CABLE_check = 0;
        else if (CABLE_check == 2) CABLE_check = 1;
        return 1;
}   
if(key==OAPI_KEY_5)
{
      if (CABLE_check == 0) CABLE_check = 2;
        else if (CABLE_check == 2) CABLE_check = 0;
        else if (CABLE_check == 1) CABLE_check = 2;
        return 1;			

}



if (!down)
		return 0;

	if (KEYMOD_SHIFT (kstate)) {
	} else if (KEYMOD_CONTROL (kstate)) {
		switch (key) {
		// Pressing keys from [Ctrl]+[1] to [Ctrl]+[9] to jettison payloads number from 0 to 10
		case OAPI_KEY_1:
			PM_DetachPayloadByIndex(0);
			return 1;
		case OAPI_KEY_2:
			PM_DetachPayloadByIndex(1);
			return 1;
		case OAPI_KEY_3:
			PM_DetachPayloadByIndex(2);
			return 1;
		case OAPI_KEY_4:
			PM_DetachPayloadByIndex(3);
			return 1;
		case OAPI_KEY_5:
			PM_DetachPayloadByIndex(4);
			return 1;
		case OAPI_KEY_6:
			PM_DetachPayloadByIndex(5);
			return 1;
		case OAPI_KEY_7:
			PM_DetachPayloadByIndex(6);
			return 1;
		case OAPI_KEY_8:
			PM_DetachPayloadByIndex(7);
			return 1;
		case OAPI_KEY_9:
			PM_DetachPayloadByIndex(8);
			return 1;
		case OAPI_KEY_0:
			PM_DetachPayloadByIndex(9);
			return 1;
		}
	} else {
		switch (key) {
		case OAPI_KEY_J:
			// Pressing J-key will starting payloads jettisoning sequence
			PM_BeginDetachPayloads();
			return 1;
		}
	}
	
return 0;
}

// ====================================================================
// clbkVisualCreated used to display UMMU initialisation message 
// because oapiDebugString() doesn't work in clbkSetClassCap
// ====================================================================
void CRANEHEAD::clbkVisualCreated (VISHANDLE vis, int refcount)
{   
	MainExternalMeshVisual = GetMesh(vis,0);

	
}
// ==============================================================
// Visual destroyed
// ==============================================================
void CRANEHEAD::clbkVisualDestroyed (VISHANDLE vis, int refcount)
{
	MainExternalMeshVisual = 0;	
}



// ========================================================================
// clbkLoadState function of Orbiter - Save scenario when user exit Orbiter 
// ========================================================================

//------------------------------------------------------------------------------------------------------------------
// This below is not mandatory for UMmu to run.
//------------------------------------------------------------------------------------------------------------------

// ==========================================================
// USING TEXT INTERFACE FOR CREW MANAGMENT (not a good idea)
//
// This is the custom functions that send oapiDebugString() Message on screen
// it simply avoid that the message is sent if our ship don't have the focus
// and ensure that message will be reminded when we focus back on ship
// the Orbiter function below clbkFocusChanged is used to erase message when
// we lost focus.
// It's a bad idea to do an UMmu user interface only by using Debug screen message 
// but if you can't do better you may use this system.
///////////////////////////////////////////////////////////////////////////////////////////

// --------------------------------------------------------------
// Orbiter's HUD callback
// used to display UMMU's message see PDF doc:
// "Example of feedback method by HUD Display"
// --------------------------------------------------------------
void CRANEHEAD::clbkDrawHUD (int mode, const HUDPAINTSPEC *hps, HDC hDC)
{
	VESSEL2::clbkDrawHUD (mode, hps, hDC);

	// UCGO display messages
	
}
void CRANEHEAD::clbkSaveState(FILEHANDLE scn)
{
char cbuf[256];
	



	// ORBITER, default vessel parameters
	SaveDefaultState (scn);


		



		sprintf (cbuf, " %0.4f",  CABLE_proc);
		oapiWriteScenario_string (scn, "CABLE", cbuf);


		 
 
	
		




	// UMmu, this will save all our members of crew in scenario
	// as airlock state depend of your ship (you may have a real animated airlock)
	// it's your responsabilites to save and reload UMmu's airlock state.
}
void CRANEHEAD::clbkLoadStateEx (FILEHANDLE scn, void *status)
{
	char *line;
	while (oapiReadScenario_nextline (scn, line)) 
	{
		// call this method to let PayloadManager to load its internal parameters
		PM_LoadState(line);

		// UMMU, Load all saved member from scenario. 
		// Return TRUE when a "UMMUCREW" line is encountered 
		// FALSE when it must pass this line to you or default parser
		


	  
	      
		      if (!_strnicmp (line, "CABLE", 5)) {
   sscanf (line+5, "%lf",  &CABLE_proc);
			}
			  

		// ORBITER, unrecognised option - pass to Orbiter's generic parser
	
		        
		// ORBITER, unrecognised option - pass to Orbiter's generic parser
		ParseScenarioLineEx (line, status);
	}
		

SetAnimation (anim_CABLE, CABLE_proc);
SetAnimation (anim_CABLE1, CABLE_proc);
			


	// as airlock state depend of your ship (you may have a real animated airlock)
	// it's your responsabilites to save and reload UMmu airlock state and set it accordingly
	// to your airlock. IE: call here "SetAirlockDoorState" TRUE of FALSE depend
	// of your animated airlock
}


DLLCLBK void secInit (HWND hEditor, OBJHANDLE hVessel){
	//Here you can define your own Scenario Editor vessel-specific pages
	//...

	//Define PayloadManager Scenario Editor interface
	PayloadManager::DefineScenarioEditorPage(hEditor, hVessel);
}
void CRANEHEAD::AttachCargo(){
 VECTOR3 aphpos, aphdir, aphrot, gaph;
             VECTOR3 shippos, shipdir, shiprot, gpship;

             // get attachment point positions based on selected point
             {
               
                    GetAttachmentParams(P1,aphpos, aphdir, aphrot);
                
              }  
             // change the position to a global one rather then a local one. This will allow me to offset it from the local center.
             // the local position is stored in gaph
             Local2Global (aphpos, gaph);

             //I now know were the attach point is in the global world
             //Now lets find out if there is a skid in range
             // Search the complete vessel list for a grappling candidate.
            // Not very scalable ...
                for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
                    OBJHANDLE hV = oapiGetVesselByIndex (i);    //get handle for ship
        //            if (strncmp (hV->GetClassName(), "QJFFS", 5)!=0  ){  //restrict to only QuadJ ships to make it easy.

                    // Look for any ship with a child attach point. This allows the Mule to grap any object
                    if (hV == GetHandle()) continue; // If self then continue onward because we don't want to grapple ourselves ...

                    oapiGetGlobalPos (hV, &gpship); // get global postion of ship and put into gpship


                       VESSEL *v = oapiGetVesselInterface (hV);
                       // Only look for child attach point
                       DWORD nAttach = v->AttachmentCount (true); //Get attachment count. I do this so that I can grap any child point.
                       if (nAttach > 0){ // Only continue if ship has a child attach point
                           for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate and check how far away from the attach point it is
                               ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
                               /* this would allow me to filter out all but QJ ships but I don't want to right now
                               const char *id = v->GetAttachmentId (hAtt);
                               if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
                               */
                               v->GetAttachmentParams (hAtt, shippos, shipdir, shiprot); //lets get the attach point position
                               v->Local2Global (shippos, gpship); // and change it to a global position Recycle of gpship cause I can
                               if (dist (gpship, gaph) < MAX_GRAP_DIST) { // Is it close enough to grab?
                                   apd = dist(gpship, gaph);
                                   // Yes! Then lets grab the little bugger and get out of here
                                    const char *id = v->GetAttachmentId (hAtt);
									
								    (do_attach=0);
								   if(!strncmp (id, "CRHD", 4))
								   {do_attach=2;}
								   
								 
								 
				   
								   if(do_attach > 0){
                                     
								 
								   
								 
                                     do_attach = 0;
                                   
                                      if ((v->GetAttachmentStatus(hAtt))||(GetAttachmentStatus(P1))) { 
 // do nothing;
      }else{
             AttachChild (hV, P1, hAtt);
                                               break;
                                        
                                   }
                                  return;
                                         }
                                 }// <-- removed return from here
                                   }}
                            } // End of for j
                       }
                              
          


void CRANEHEAD::DetachCargo ()
{
    
             DetachChild(P1,0);
           
             
}