// ==============================================================
//                 ORBITER MODULE: EAGLEHANGAR2
//                  Part of the ORBITER SDK
//          Copyright (C) 2002-2004 Martin Schweiger
//                   All rights reserved
//
// EAGLEHANGAR2.cpp
// Control module for EAGLEHANGAR2 vessel class
//
// Notes:
// This is an example for a "minimal" vessel implementation which
// only overloads the clbkSetClassCaps method to define vessel
// capabilities and otherwise uses the default VESSEL class
// behaviour.
// ==============================================================



//#include "orbitersdk.h"
#include "UMmuSDK.h"
#include "PayloadManager.h"
#include "resource.h"
// ==============================================================
// Some vessel parameters
// ==============================================================
const double PB_FUELMASS = 33000;
const double PB_ISP = 50000;

const double PB_MAXRCSTH = 5e3;//9.9e4
const double PB_MAXHOVERTH =8.5e5;
// Interface for derived vessel class: QJBStar
// ==========================================================

class CRANEHEAD:
	public VesselWithPM<CRANEHEAD>
{
public:
	CRANEHEAD (OBJHANDLE hObj, int fmodel);
	~CRANEHEAD ();
	void clbkSaveState(FILEHANDLE scn);
       void clbkPostCreation (void);
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *status);
	int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
 	void DefineAnimations(void); 
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);
	void clbkPostStep (double simtt, double simdt, double mjd);
	void clbkDrawHUD (int mode, const HUDPAINTSPEC *hps, HDC hDC);

	void RevertGEAR (void);
		void RevertRAMP (void);

		void RevertDOOR (void);
			void RevertGEARCOVER (void);

		void AttachCargo();
    void DetachCargo();


	//void PM_clbkPayloadJettisoned(int slot_idx, OBJHANDLE jettisoned_ship);
	//void PM_clbkVehicleCapsChanged();


char j_name[32];
	double j_timer;


	void CRANEHEAD::SelectCockpitView (int CAM); 


int JohnSoundID;
int j,ROTOR,do_attach;

#define HH65Engines				50
#define HH65Gear			   	51
#define HH65Start			   	52


double CABLE_proc, apd, MAX_GRAP_DIST, CABLEFACTOR, P1_INT_POS, CABLE_check,RAMP_proc;


double LIFT_SPEED,GEAR_proc,ROTOR_proc,ROTOR_SPEED,DOOR_proc,ROTOR1,ALT,GEARCOVER_proc;
//double DOOR2_proc;
//double TCAR_proc; 
double db,simdt;
UINT BUG0,CREW1;
MESHHANDLE TUBE;

VECTOR3 CAM_pos,CAM1_pos;


ATTACHMENTHANDLE P1,P2;








private:
int CRANEHEADID,SPEED,CAM;
VECTOR3 P1_pos,P2_pos;
double WINCH_SPEED;

UINT anim_CABLE;
UINT anim_CABLE1;


};
